-- Filled with default params, feel free to play with those

-- This function will allocate mobj type named MT_<name_you_put_here>, so
-- this statement bellow will allocate MT_EXAMPLE_GRAPPLE_POINT
-- Notice that you don't need to add the MT_ prefix
grapple.registerGrapplePoint("EXAMPLE_GRAPPLE_POINT", {
	-- Distance between player and grapple point at which player can start grapple
    distance = FRACUNIT*2000,
	
	-- Stiffness of "rope", FRACUNIT/16 seems optimal to me but still feel free to tweak it
    stiffness = FRACUNIT/16,
	
	-- If true, will check angle between player looking direction and direction to grapple point
	-- I recommend keeping it and next setting default because it prevents accidently using
	-- grapple point located behind you when its closer than some other located in front
    angle_check = true,
	-- Cosine of angle used in previous value (or cosine of half of angle to be precise, since 0 is cosine of 90 degrees)
	-- 0 is default meaning any grapple points behind player aren't considered usable
    angle_check_cos = 0,
	
	-- Limits player's vertical speed, converting it into horyzontal speed
    cut_vertical_momentum = true,
	-- Any vertical speed above that value gets converted to horyzontal speed
    max_vertical_momentum = 40*FRACUNIT,
	
	-- If player is holding to grapple point and presses accel button, they will accelerate
	-- slightly in direction they're looking
    player_accel = 2*FRACUNIT/3,
	
	-- Object floating above player and pointing to closest available grapple point
	-- MT_DEFAULT_GRAPPLE_INDICATOR is provided by grapple script
    indicator_mobj_type = MT_DEFAULT_GRAPPLE_INDICATOR,
	
	-- Object type used to construct a "rope", purely visual
    rope_mobj_type = MT_DEFAULT_GRAPPLE_ROPE,
	
	-- Sound played when starting grapple
    grapple_start_sound = sfx_s3k4a,
	
	-- Sound played when releasing grapple
    grapple_end_sound = nil,
})

-- If you want to add some extra logic, feel free to, using newly allocated mobj type
local MT_EXAMPLE_GRAPPLE_POINT = MT_EXAMPLE_GRAPPLE_POINT